package org.sonatype.plugin.nexus.testenvironment;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on nexus-test-environment-maven-plugin.<br/> Call <pre>  mvn nexus-test-environment:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Fri Aug 17 15:39:29 CDT 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.sonatype.nexus.plugins:nexus-test-environment-maven-plugin:2.1.2", 0 );
        append( sb, "", 0 );

        append( sb, "Nexus : Test Harness : Test Environment Setup Plugin", 0 );
        append( sb, "Sonatype Nexus Repository Manager", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 5 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "nexus-test-environment:help", 0 );
            append( sb, "Display help information on nexus-test-environment-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0nexus-test-environment:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package".equals( goal ) )
        {
            append( sb, "nexus-test-environment:package", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "destinationFile (Default: ${project.build.directory}/${project.build.finalName}-test-resources.zip)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesSourceLocation (Default: ${basedir}/resources)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testClasses (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testResources (Default: ${project.testResources})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testSkip", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${maven.test.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "setup-environment".equals( goal ) )
        {
            append( sb, "nexus-test-environment:setup-environment", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "destination (Default: ${project.build.directory}/nexus)", 2 );
                append( sb, "Where nexus instance should be extracted", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "emmaArtifact", 2 );
                append( sb, "Emma used on ITs", 3 );
                append( sb, "", 0 );

                append( sb, "excludeTestDependencies", 2 );
                append( sb, "If true plugin won\'t include nexus-plugin dependencies with scope test", 3 );
                append( sb, "", 0 );

                append( sb, "exclusions", 2 );
                append( sb, "Prevents a given artifact to be copy into nexus plugin repository", 3 );
                append( sb, "", 0 );

                append( sb, "extractNexusPluginsJavascript (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "extraResourcesArtifacts", 2 );
                append( sb, "Resources to be unpacked and then contents copied into Nexus default-configs", 3 );
                append( sb, "", 0 );

                append( sb, "localRepository", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${localRepository}", 3 );
                append( sb, "", 0 );

                append( sb, "mavenArtifact", 2 );
                append( sb, "Maven used on ITs", 3 );
                append( sb, "", 0 );

                append( sb, "mavenBaseDir", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "mavenLocation (Default: ${project.build.directory}/maven)", 2 );
                append( sb, "Where Maven instance should be created", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleArtifact", 2 );
                append( sb, "Artifact file containing nexus bundle", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleExcludes", 2 );
                append( sb, "Comma separated list of patterns to delete from an unpacked Nexus bundle. Patterns are deleted before any optional plugins or other external resources are installed", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleName", 2 );
                append( sb, "Name of teh directory created out of nexus artifact bundle. Default is ${nexusBundleArtifactId}-${nexusBundleArtifactVersion}.", 3 );
                append( sb, "", 0 );

                append( sb, "nexusPluginsArtifacts", 2 );
                append( sb, "Nexus plugin artifacts to be installed into the Nexus instance under test.", 3 );
                append( sb, "", 0 );

                append( sb, "pluginSkip", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${test-env.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "promoteOptionalPlugin (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "remoteRepositories", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${project.remoteArtifactRepositories}", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesDestinationLocation (Default: ${project.build.directory}/resources)", 2 );
                append( sb, "This directory is where the default-configs included inside the this plugin will be extracted to BEFORE they are copied into the nexus work dir. A project property \'test-resources-folder\' contains the absolute path of this directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesSourceLocation (Default: ${basedir}/resources)", 2 );
                append( sb, "Resources in the test project can be added beneath this directory so that", 3 );
                append( sb, "", 0 );

                append( sb, "setupEmma (Default: true)", 2 );
                append( sb, "When true setup emma", 3 );
                append( sb, "", 0 );

                append( sb, "setupMaven (Default: true)", 2 );
                append( sb, "When true setup a maven instance", 3 );
                append( sb, "", 0 );

                append( sb, "staticPorts", 2 );
                append( sb, "Known ports can be manually set as part of the configuration", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testResourcesDirectory (Default: ${basedir}/src/test/resources)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testSkip", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${maven.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "unpackPluginWebapps", 2 );
                append( sb, "If there is one or more *-webapp.zip files in runtime/apps/nexus/plugin-repository, then unpack that zip to nexus base dir and delete the original file", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "setup-nexus-plugin-environment".equals( goal ) )
        {
            append( sb, "nexus-test-environment:setup-nexus-plugin-environment", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "destination (Default: ${project.build.directory}/nexus)", 2 );
                append( sb, "Where nexus instance should be extracted", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "emmaArtifact", 2 );
                append( sb, "Emma used on ITs", 3 );
                append( sb, "", 0 );

                append( sb, "excludeTestDependencies", 2 );
                append( sb, "If true plugin won\'t include nexus-plugin dependencies with scope test", 3 );
                append( sb, "", 0 );

                append( sb, "exclusions", 2 );
                append( sb, "Prevents a given artifact to be copy into nexus plugin repository", 3 );
                append( sb, "", 0 );

                append( sb, "extractNexusPluginsJavascript (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "extraResourcesArtifacts", 2 );
                append( sb, "Resources to be unpacked and then contents copied into Nexus default-configs", 3 );
                append( sb, "", 0 );

                append( sb, "localRepository", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${localRepository}", 3 );
                append( sb, "", 0 );

                append( sb, "mavenArtifact", 2 );
                append( sb, "Maven used on ITs", 3 );
                append( sb, "", 0 );

                append( sb, "mavenBaseDir", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "mavenLocation (Default: ${project.build.directory}/maven)", 2 );
                append( sb, "Where Maven instance should be created", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleArtifact", 2 );
                append( sb, "Artifact file containing nexus bundle", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleExcludes", 2 );
                append( sb, "Comma separated list of patterns to delete from an unpacked Nexus bundle. Patterns are deleted before any optional plugins or other external resources are installed", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleName", 2 );
                append( sb, "Name of teh directory created out of nexus artifact bundle. Default is ${nexusBundleArtifactId}-${nexusBundleArtifactVersion}.", 3 );
                append( sb, "", 0 );

                append( sb, "nexusPluginsArtifacts", 2 );
                append( sb, "Nexus plugin artifacts to be installed into the Nexus instance under test.", 3 );
                append( sb, "", 0 );

                append( sb, "nexusVersion", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexus.version}", 3 );
                append( sb, "", 0 );

                append( sb, "pluginSkip", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${test-env.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "promoteOptionalPlugin (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "remoteRepositories", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${project.remoteArtifactRepositories}", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesDestinationLocation (Default: ${project.build.directory}/resources)", 2 );
                append( sb, "This directory is where the default-configs included inside the this plugin will be extracted to BEFORE they are copied into the nexus work dir. A project property \'test-resources-folder\' contains the absolute path of this directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesSourceLocation (Default: ${basedir}/resources)", 2 );
                append( sb, "Resources in the test project can be added beneath this directory so that", 3 );
                append( sb, "", 0 );

                append( sb, "setupEmma (Default: true)", 2 );
                append( sb, "When true setup emma", 3 );
                append( sb, "", 0 );

                append( sb, "setupMaven (Default: true)", 2 );
                append( sb, "When true setup a maven instance", 3 );
                append( sb, "", 0 );

                append( sb, "staticPorts", 2 );
                append( sb, "Known ports can be manually set as part of the configuration", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testResourcesDirectory (Default: ${basedir}/src/test/resources)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testSkip", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${maven.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "unpackPluginWebapps", 2 );
                append( sb, "If there is one or more *-webapp.zip files in runtime/apps/nexus/plugin-repository, then unpack that zip to nexus base dir and delete the original file", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "unpackage".equals( goal ) )
        {
            append( sb, "nexus-test-environment:unpackage", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "destination (Default: ${project.build.directory}/nexus)", 2 );
                append( sb, "Where nexus instance should be extracted", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "", 0 );

                append( sb, "emmaArtifact", 2 );
                append( sb, "Emma used on ITs", 3 );
                append( sb, "", 0 );

                append( sb, "excludeTestDependencies", 2 );
                append( sb, "If true plugin won\'t include nexus-plugin dependencies with scope test", 3 );
                append( sb, "", 0 );

                append( sb, "exclusions", 2 );
                append( sb, "Prevents a given artifact to be copy into nexus plugin repository", 3 );
                append( sb, "", 0 );

                append( sb, "extractNexusPluginsJavascript (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "extraResourcesArtifacts", 2 );
                append( sb, "Resources to be unpacked and then contents copied into Nexus default-configs", 3 );
                append( sb, "", 0 );

                append( sb, "extraTestSuites", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "localRepository", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${localRepository}", 3 );
                append( sb, "", 0 );

                append( sb, "mavenArtifact", 2 );
                append( sb, "Maven used on ITs", 3 );
                append( sb, "", 0 );

                append( sb, "mavenBaseDir", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "mavenLocation (Default: ${project.build.directory}/maven)", 2 );
                append( sb, "Where Maven instance should be created", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleArtifact", 2 );
                append( sb, "Artifact file containing nexus bundle", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleExcludes", 2 );
                append( sb, "Comma separated list of patterns to delete from an unpacked Nexus bundle. Patterns are deleted before any optional plugins or other external resources are installed", 3 );
                append( sb, "", 0 );

                append( sb, "nexusBundleName", 2 );
                append( sb, "Name of teh directory created out of nexus artifact bundle. Default is ${nexusBundleArtifactId}-${nexusBundleArtifactVersion}.", 3 );
                append( sb, "", 0 );

                append( sb, "nexusPluginsArtifacts", 2 );
                append( sb, "Nexus plugin artifacts to be installed into the Nexus instance under test.", 3 );
                append( sb, "", 0 );

                append( sb, "pluginSkip", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${test-env.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "promoteOptionalPlugin (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "remoteRepositories", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${project.remoteArtifactRepositories}", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesDestinationLocation (Default: ${project.build.directory}/resources)", 2 );
                append( sb, "This directory is where the default-configs included inside the this plugin will be extracted to BEFORE they are copied into the nexus work dir. A project property \'test-resources-folder\' contains the absolute path of this directory.", 3 );
                append( sb, "", 0 );

                append( sb, "resourcesSourceLocation (Default: ${basedir}/resources)", 2 );
                append( sb, "Resources in the test project can be added beneath this directory so that", 3 );
                append( sb, "", 0 );

                append( sb, "setupEmma (Default: true)", 2 );
                append( sb, "When true setup emma", 3 );
                append( sb, "", 0 );

                append( sb, "setupMaven (Default: true)", 2 );
                append( sb, "When true setup a maven instance", 3 );
                append( sb, "", 0 );

                append( sb, "staticPorts", 2 );
                append( sb, "Known ports can be manually set as part of the configuration", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testResourcesDirectory (Default: ${basedir}/src/test/resources)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "testSkip", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "Expression: ${maven.test.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "unpackPluginWebapps", 2 );
                append( sb, "If there is one or more *-webapp.zip files in runtime/apps/nexus/plugin-repository, then unpack that zip to nexus base dir and delete the original file", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
